ffi = require('ffi')
require 'geometry/vec2'
require 'geometry/vec3'
require 'geometry/vec4'
require 'geometry/mat4'

local __old_type = type
type = function(obj)
	-- custom engine types
    if ffi.istype('vec_2', obj) then
		return 'vec2'
	elseif ffi.istype('vec_3', obj) then
		return 'vec3'
	elseif ffi.istype('vec_4', obj) then
		return 'vec4'
	elseif ffi.istype('mat_4', obj) then
		return 'mat4'
    end
    return __old_type(obj)
end